Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -2,13 +2,9 @@
 # Also indentation by a single tab
 
-SUBDIRS = Actions UIElements
-
-# this includes source files that need to be present at multiple points
-HELPERSOURCE =  \
-  Helpers/Assert.cpp \
-  Helpers/MemDebug.cpp
-		        
+SUBDIRS = Actions Exceptions Helpers LinearAlgebra Parser UIElements
+
 ATOMSOURCE = \
   atom.cpp \
+  AtomicInfo.cpp \
   atom_atominfo.cpp \
   atom_bondedparticle.cpp \
@@ -21,4 +17,5 @@
 ATOMHEADER = \
   atom.hpp \
+  AtomicInfo.hpp \
   atom_atominfo.hpp \
   atom_bondedparticle.hpp \
@@ -30,18 +27,4 @@
   atom_trajectoryparticleinfo.hpp
 
-LINALGSOURCE = \
-  ${HELPERSOURCE} \
-  gslmatrix.cpp \
-  gslvector.cpp \
-  linearsystemofequations.cpp \
-  Space.cpp \
-  vector.cpp
-			   
-LINALGHEADER = gslmatrix.hpp \
-  gslvector.hpp \
-  linearsystemofequations.hpp \
-  Space.hpp \
-  vector.hpp
-			   
 ANALYSISSOURCE = \
   analysis_bonds.cpp \
@@ -75,23 +58,4 @@
   Actions/MethodAction.hpp \
   Actions/Process.hpp
-  
-
-PARSERSOURCE = \
-  Parser/ChangeTracker.cpp \
-  Parser/FormatParser.cpp \
-  Parser/FormatParserStorage.cpp \
-  Parser/MpqcParser.cpp \
-  Parser/PcpParser.cpp \
-  Parser/TremoloParser.cpp \
-  Parser/XyzParser.cpp
-
-PARSERHEADER = \
-  Parser/ChangeTracker.hpp \
-  Parser/FormatParser.hpp \
-  Parser/FormatParserStorage.hpp \
-  Parser/MpqcParser.hpp \
-  Parser/PcpParser.hpp \
-  Parser/TremoloParser.hpp \
-  Parser/XyzParser.hpp
 
 PATTERNSOURCE = \
@@ -101,59 +65,58 @@
   Patterns/Observer.hpp \
   Patterns/Singleton.hpp
-
-QTUIMOC_HEADER = UIElements/QT4/QTDialog.hpp \
-				 UIElements/QT4/QTMainWindow.hpp \
-				 UIElements/Menu/QT4/QTMenu.hpp \
-				 UIElements/Views/QT4/QTWorldView.hpp \
-				 UIElements/Views/QT4/GLMoleculeView.hpp \
-				 UIElements/Views/QT4/QTMoleculeView.hpp \
-				 UIElements/Views/QT4/QTStatusBar.hpp
- 
-QTUIMOC_TARGETS = QTMainWindow.moc.cpp \
-	              QTMenu.moc.cpp\
-	              QTDialog.moc.cpp \
-	              QTWorldView.moc.cpp \
-	              GLMoleculeView.moc.cpp \
-	              QTMoleculeView.moc.cpp \
-	              QTStatusBar.moc.cpp
-
+  
+SHAPESOURCE = \
+  Shapes/BaseShapes.cpp \
+  Shapes/Shape.cpp \
+  Shapes/ShapeOps.cpp
+SHAPEHEADER = \
+  Shapes/BaseShapes.hpp \
+  Shapes/Shape.hpp \
+  Shapes/ShapeOps.hpp
+
+  
 DESCRIPTORSOURCE = Descriptors/AtomDescriptor.cpp \
   Descriptors/AtomIdDescriptor.cpp \
+  Descriptors/AtomSelectionDescriptor.cpp \
+  Descriptors/AtomShapeDescriptor.cpp \
   Descriptors/AtomTypeDescriptor.cpp \
   Descriptors/MoleculeDescriptor.cpp \
+  Descriptors/MoleculeFormulaDescriptor.cpp \
   Descriptors/MoleculeIdDescriptor.cpp \
   Descriptors/MoleculeNameDescriptor.cpp \
-  Descriptors/MoleculePtrDescriptor.cpp 
+  Descriptors/MoleculePtrDescriptor.cpp \
+  Descriptors/MoleculeSelectionDescriptor.cpp
 				   
 
 DESCRIPTORHEADER = Descriptors/AtomDescriptor.hpp \
   Descriptors/AtomIdDescriptor.hpp \
+  Descriptors/AtomSelectionDescriptor.hpp \
+  Descriptors/AtomShapeDescriptor.hpp \
   Descriptors/AtomTypeDescriptor.hpp \
   Descriptors/MoleculeDescriptor.hpp \
+  Descriptors/MoleculeFormulaDescriptor.hpp \
   Descriptors/MoleculeIdDescriptor.hpp \
   Descriptors/MoleculeNameDescriptor.hpp \
-  Descriptors/MoleculePtrDescriptor.hpp
-				   
-EXCEPTIONSOURCE = Exceptions/CustomException.cpp \
-				  Exceptions/LinearDependenceException.cpp \
-				  Exceptions/MathException.cpp \
-				  Exceptions/SkewException.cpp \
-				  Exceptions/ZeroVectorException.cpp
+  Descriptors/MoleculePtrDescriptor.hpp \
+  Descriptors/MoleculeSelectionDescriptor.cpp
+
+
+QTUIMOC_HEADER = UIElements/QT4/QTDialog.hpp \
+	UIElements/QT4/QTMainWindow.hpp \
+	UIElements/Menu/QT4/QTMenu.hpp \
+	UIElements/Views/QT4/QTWorldView.hpp \
+	UIElements/Views/QT4/GLMoleculeView.hpp \
+	UIElements/Views/QT4/QTMoleculeView.hpp \
+	UIElements/Views/QT4/QTStatusBar.hpp
 				  
-EXCEPTIONHEADER = Exceptions/CustomException.hpp \
-				  Exceptions/LinearDependenceException.hpp \
-				  Exceptions/MathException.hpp \
-				  Exceptions/SkewException.hpp \
-				  Exceptions/ZeroVectorException.hpp
-				  
-QTUISOURCE = ${QTUIMOC_TARGETS} \
-			 UIElements/QT4/QTMainWindow.cpp \
-			 UIElements/QT4/QTDialog.cpp \
-			 UIElements/QT4/QTUIFactory.cpp \
-			 UIElements/Menu/QT4/QTMenu.cpp \
-			 UIElements/Views/QT4/QTWorldView.cpp \
-			 UIElements/Views/QT4/GLMoleculeView.cpp \
-			 UIElements/Views/QT4/QTMoleculeView.cpp \
-			 UIElements/Views/QT4/QTStatusBar.cpp
+QTUISOURCE = allmocs.moc.cpp \
+	UIElements/QT4/QTMainWindow.cpp \
+	UIElements/QT4/QTDialog.cpp \
+	UIElements/QT4/QTUIFactory.cpp \
+	UIElements/Menu/QT4/QTMenu.cpp \
+	UIElements/Views/QT4/QTWorldView.cpp \
+	UIElements/Views/QT4/GLMoleculeView.cpp \
+	UIElements/Views/QT4/QTMoleculeView.cpp \
+	UIElements/Views/QT4/QTStatusBar.cpp
              
 QTUIHEADER = ${QTUIMOC_HEADER} UIElements/QT4/QTUIFactory.hpp
@@ -161,31 +124,49 @@
 QTUI_DEFS =
 
-SOURCE = \
+TESSELATIONSOURCE = \
+  BoundaryLineSet.cpp \
+  BoundaryPointSet.cpp \
+  BoundaryPolygonSet.cpp \
+  BoundaryTriangleSet.cpp \
+  CandidateForTesselation.cpp \
+  PointCloud.cpp \
+  tesselation.cpp \
+  tesselationhelpers.cpp \
+  TesselPoint.cpp
+  
+TESSELATIONHEADER = \
+  BoundaryLineSet.hpp \
+  BoundaryPointSet.hpp \
+  BoundaryPolygonSet.hpp \
+  BoundaryTriangleSet.hpp \
+  CandidateForTesselation.hpp \
+  PointCloud.hpp \
+  tesselation.hpp \
+  tesselationhelpers.hpp \
+  TesselPoint.hpp
+
+MOLECUILDERSOURCE = \
   ${ANALYSISSOURCE} \
   ${ACTIONSSOURCE} \
   ${ATOMSOURCE} \
   ${PATTERNSOURCE} \
-  ${PARSERSOURCE} \
+  ${SHAPESOURCE} \
   ${DESCRIPTORSOURCE} \
-  ${HELPERSOURCE} \
-  ${EXCEPTIONSOURCE} \
+  ${TESSELATIONSOURCE} \
   bond.cpp \
   bondgraph.cpp \
   boundary.cpp \
+  Box.cpp \
   CommandLineParser.cpp \
   config.cpp \
   ConfigFileBuffer.cpp \
+  defs.cpp \
   element.cpp \
   elements_db.cpp \
   ellipsoid.cpp \
-  errorlogger.cpp \
+  Formula.cpp \
   graph.cpp \
-  helpers.cpp \
-  info.cpp \
   leastsquaremin.cpp \
-  Line.cpp \
   linkedcell.cpp \
-  log.cpp \
-  logger.cpp \
   moleculelist.cpp \
   molecule.cpp \
@@ -197,26 +178,21 @@
   parser.cpp \
   periodentafel.cpp \
-  Plane.cpp \
-  Space.cpp \
-  tesselation.cpp \
-  tesselationhelpers.cpp \
   ThermoStatContainer.cpp \
   triangleintersectionlist.cpp \
-  vector.cpp \
-  vector_ops.cpp \
-  verbose.cpp \
+  UIElements/UIFactory.cpp \
   World.cpp
 
-HEADER = \
+MOLECUILDERHEADER = \
   ${ANALYSISHEADER} \
   ${ACTIONSHEADER} \
   ${ATOMHEADER} \
-  ${PARSERHEADER} \
   ${PATTERNHEADER} \
+  ${SHAPEHEADER} \
   ${DESCRIPTORHEADER} \
-  ${EXCEPTIONHEADER} \
+  ${TESSELATIONHEADER} \
   bond.hpp \
   bondgraph.hpp \
   boundary.hpp \
+  Box.hpp \
   CommandLineParser.hpp \
   config.hpp \
@@ -226,33 +202,71 @@
   elements_db.hpp \
   ellipsoid.hpp \
-  errorlogger.hpp \
+  Formula.hpp \
   graph.hpp \
-  helpers.hpp \
-  info.hpp \
   leastsquaremin.hpp \
-  Line.hpp \
   linkedcell.hpp \
   lists.hpp \
-  log.hpp \
-  logger.hpp \
   molecule.hpp \
   molecule_template.hpp \
   parser.hpp \
   periodentafel.hpp \
-  Plane.hpp \
   stackclass.hpp \
-  tesselation.hpp \
-  tesselationhelpers.hpp \
   ThermoStatContainer.hpp \
   triangleintersectionlist.hpp \
-  verbose.hpp \
-  vector_ops.hpp \
+  UIElements/UIFactory.hpp \
   World.hpp 
 
-# the following files are no longer used:
-#  memoryallocator.hpp \
-#  memoryallocator.cpp \
-#  memoryusageobserver.hpp \
-#  memoryusageobserver.cpp
+lib_LTLIBRARIES = libMolecuilder-@MOLECUILDER_API_VERSION@.la
+libMolecuilder_includedir = $(includedir)/molecuilder-$(MOLECUILDER_API_VERSION)/Actions/
+libMolecuilder_LIBS = \
+	LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	${BOOST_PROGRAM_OPTIONS_LIB}
+
+#	UIElements/libMolecuilderUI.a \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB}
+
+nobase_libMolecuilder_include_HEADERS = ${MOLECUILDERHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libMolecuilder_@MOLECUILDER_API_VERSION@_la_SOURCES = ${MOLECUILDERSOURCE} $(srcdir)/version.c
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+libMolecuilder_@MOLECUILDER_API_VERSION@_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilder_libincludedir = $(libdir)/molecuilder-$(MOLECUILDER_API_VERSION)/include
+nodist_libMolecuilder_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+pkgconfigdir = $(libdir)/pkgconfig
+pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
+
 
 BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB)
@@ -260,14 +274,11 @@
 INCLUDES = -I$(top_srcdir)/src/unittests -I$(top_srcdir)/src/Actions -I$(top_srcdir)/src/UIElements
 
-noinst_LIBRARIES = libmolecuilder.a libgslwrapper.a libmenu.a libparser.a
+noinst_LIBRARIES = libmenu.a
 bin_PROGRAMS = molecuilder molecuildergui joiner analyzer
+EXTRA_PROGRAMS = unity
 
 molecuilderdir = ${bindir}
 
-libmolecuilder_a_SOURCES = ${SOURCE} ${HEADER}
-
 libmenu_a_SOURCES = ${UISOURCE} ${UIHEADER} 
-libparser_a_SOURCES = ${PARSERSOURCE} ${PARSERHEADER}
-libgslwrapper_a_SOURCES = ${LINALGSOURCE} ${LINALGHEADER}
 
 molecuilder_DATA = elements.db valence.db orbitals.db Hbonddistance.db Hbondangle.db
@@ -276,20 +287,62 @@
 #molecuilder_CXXFLAGS += -DNO_CACHING
 molecuilder_LDFLAGS = $(BOOST_LIB)
-molecuilder_SOURCES = ${LEGACYSOURCE} builder.cpp
-molecuilder_SOURCES += $(srcdir)/version.c
-molecuilder_LDADD = UIElements/libMolecuilderUI.a Actions/libMolecuilderActions.a libmolecuilder.a libparser.a libgslwrapper.a $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB}
+molecuilder_SOURCES = builder.cpp
+molecuilder_LDADD = \
+	UIElements/libMolecuilderUI-@MOLECUILDER_API_VERSION@.la \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	libMolecuilder-@MOLECUILDER_API_VERSION@.la \
+	Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB} \
+	${BOOST_PROGRAM_OPTIONS_LIB}
+
 
 #Stuff for building the GUI using QT
-molecuildergui_SOURCES = ${QTUISOURCE} ${LEGACYSOURCE} builder.cpp
-molecuildergui_SOURCES += $(srcdir)/version.c
+molecuildergui_SOURCES = ${QTUISOURCE} builder.cpp
 molecuildergui_CXXFLAGS = ${QT_CXXFLAGS} ${GLU_CXXFLAGS} -DUSE_GUI_QT
 molecuildergui_LDFLAGS = $(BOOST_LIB) ${QT_LDFLAGS} ${GLU_LDFLAGS}
-molecuildergui_LDADD = UIElements/libMolecuilderUI.a Actions/libMolecuilderActions.a libmolecuilder.a libparser.a libgslwrapper.a $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB}  ${GUI_LIBS}
-
-joiner_SOURCES = joiner.cpp datacreator.cpp parser.cpp datacreator.hpp helpers.hpp parser.hpp periodentafel.hpp
-joiner_LDADD = libmolecuilder.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
-
-analyzer_SOURCES = analyzer.cpp datacreator.cpp parser.cpp helpers.hpp periodentafel.hpp parser.hpp datacreator.hpp 
-analyzer_LDADD = libmolecuilder.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
+
+unity_SOURCES = unity.cpp
+unity_LDADD = $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB}
+
+molecuildergui_LDADD = \
+	UIElements/libMolecuilderUI-@MOLECUILDER_API_VERSION@.la \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	libMolecuilder-@MOLECUILDER_API_VERSION@.la \
+	Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB} \
+	${BOOST_PROGRAM_OPTIONS_LIB} \
+	${GUI_LIBS}
+
+joiner_SOURCES = joiner.cpp datacreator.cpp datacreator.hpp periodentafel.hpp
+joiner_LDADD = \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	libMolecuilder-@MOLECUILDER_API_VERSION@.la \
+	Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB} \
+	${BOOST_PROGRAM_OPTIONS_LIB}
+
+analyzer_SOURCES = analyzer.cpp datacreator.cpp periodentafel.hpp datacreator.hpp 
+analyzer_LDADD = \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	libMolecuilder-@MOLECUILDER_API_VERSION@.la \
+	Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB} \
+	${BOOST_PROGRAM_OPTIONS_LIB}
 
 #Rules needed for QT4
@@ -297,5 +350,6 @@
 # Therfore `%'-rules do not seem to work
 #Quick fix to get it done otherwise
-${QTUIMOC_TARGETS}: ${QTUIMOC_HEADER}
+allmocs.moc.cpp: ${QTUIMOC_HEADER}
+	echo "" > allmocs.moc.cpp;\
 	list='$(QTUIMOC_HEADER)'; for header in $$list; do \
 	echo "Making mocfile for $$header"; \
@@ -303,8 +357,7 @@
 	$(MOC) $(srcdir)/$$header -o $$target \
 	|| eval $$failcom; \
+	echo "#include \"$$target\"" >> allmocs.moc.cpp; \
 	done;
 
-MOSTLYCLEANFILES = ${QTUIMOC_TARGETS}
-	
 #EXTRA_DIST = ${molecuilder_DATA}
 
@@ -325,2 +378,18 @@
 
 
+unity.cpp: ${MOLECUILDERSOURCE} ${MOLECUILDERHEADER}
+	echo "#include \"$(srcdir)/Helpers/MemDebug.cpp\"" >  unity.cpp; \
+	list='$(MOLECUILDERSOURCE)'; for file in $$list; do \
+  	echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
+	done; \
+	subdirs='$(SUBDIRS)';for directory in $$subdirs; do\
+		olddir=$$PWD;\
+		cd $$directory && make unity.cpp;\
+		cd $$olddir;\
+		echo "#include \"$$directory/unity.cpp\"" >> unity.cpp;\
+	done;\
+	echo "#include \"$(srcdir)/builder.cpp\"" >> unity.cpp;
+	echo "#include \"$(srcdir)/version.c\"" >> unity.cpp;
+
+MOSTLYCLEANFILES = allmocs.moc.cpp unity.cpp 
+	
Index: src/Parser/ChangeTracker.cpp
===================================================================
--- src/Parser/ChangeTracker.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Parser/ChangeTracker.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,8 +6,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
+
 #include "Parser/ChangeTracker.hpp"
 #include "Patterns/Singleton_impl.hpp"
-
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 /**
@@ -15,7 +22,7 @@
  */
 ChangeTracker::ChangeTracker() :
-  Observable("ChangeTracker")
+  Observable("ChangeTracker"),
+  isConsistent(true)
 {
-  isConsistent = true;
   World::getInstance().signOn(this);
 }
@@ -49,4 +56,5 @@
  */
 void ChangeTracker::saveStatus() {
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes." << std::endl);
   if (hasChanged()) {
     notifyAll();
Index: src/Parser/FormatParser.cpp
===================================================================
--- src/Parser/FormatParser.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Parser/FormatParser.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: metzler
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -17,8 +22,8 @@
  */
 FormatParser::FormatParser() :
-  Observer("FormatParser")
+  Observer("FormatParser"),
+  saveStream(NULL)
 {
   ChangeTracker::getInstance().signOn(this);
-  saveStream = NULL;
 }
 
Index: src/Parser/FormatParserStorage.cpp
===================================================================
--- src/Parser/FormatParserStorage.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Parser/FormatParserStorage.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,11 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
 #include <iostream>
 #include <fstream>
@@ -17,6 +24,6 @@
 #include "Parser/XyzParser.hpp"
 
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 #include "Helpers/Assert.hpp"
Index: src/Parser/Makefile.am
===================================================================
--- src/Parser/Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Parser/Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,74 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+INCLUDES = -I$(top_srcdir)/src
+
+AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
+AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
+
+PARSERSOURCE = \
+  ChangeTracker.cpp \
+  FormatParser.cpp \
+  FormatParserStorage.cpp \
+  MpqcParser.cpp \
+  PcpParser.cpp \
+  TremoloParser.cpp \
+  XyzParser.cpp
+
+PARSERHEADER = \
+  ChangeTracker.hpp \
+  FormatParser.hpp \
+  FormatParserStorage.hpp \
+  MpqcParser.hpp \
+  PcpParser.hpp \
+  TremoloParser.hpp \
+  XyzParser.hpp
+
+
+lib_LTLIBRARIES = libMolecuilderParser-@MOLECUILDER_API_VERSION@.la
+libMolecuilderParser_includedir = $(includedir)/molecuilder-$(MOLECUILDER_API_VERSION)/Actions/
+nobase_libMolecuilderParser_include_HEADERS = ${PARSERHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libMolecuilderParser_@MOLECUILDER_API_VERSION@_la_SOURCES = ${PARSERSOURCE}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+libMolecuilderParser_@MOLECUILDER_API_VERSION@_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilderParser_libincludedir = $(libdir)/molecuilder-$(MOLECUILDER_API_VERSION)/include
+nodist_libMolecuilderParser_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+pkgconfigdir = $(libdir)/pkgconfig
+pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
+
+unity.cpp:
+	echo "" >  unity.cpp; \
+	list='$(PARSERSOURCE)'; for file in $$list; do \
+	  echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
+	done;
+	
+MOSTLYCLEANFILES = unity.cpp
Index: src/Parser/MpqcParser.cpp
===================================================================
--- src/Parser/MpqcParser.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Parser/MpqcParser.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,11 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
 #include "MpqcParser.hpp"
 
@@ -11,8 +18,8 @@
 #include "config.hpp"
 #include "element.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "periodentafel.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
 #include "World.hpp"
 
@@ -22,14 +29,11 @@
  */
 MpqcParser::MpqcParser() : HessianPresent(false)
-{
-
-}
+{}
 
 /** Destructor of MpqcParser.
  *
  */
-MpqcParser::~MpqcParser() {
-
-}
+MpqcParser::~MpqcParser()
+{}
 
 /** Load an MPQC config file into the World.
@@ -43,4 +47,6 @@
 void MpqcParser::save(ostream *file)
 {
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes to MPQC ." << std::endl);
+
   if (HessianPresent)
     saveHessian(file);
@@ -60,5 +66,5 @@
   // calculate center
   for (vector<atom *>::iterator runner = allatoms.begin();runner != allatoms.end(); ++runner)
-    center += (*runner)->x;
+    center += (*runner)->getPosition();
   center.Scale(1./allatoms.size());
 
@@ -108,5 +114,5 @@
   // calculate center
   for (vector<atom *>::iterator runner = allatoms.begin();runner != allatoms.end(); ++runner)
-    center += (*runner)->x;
+    center += (*runner)->getPosition();
   center.Scale(1./allatoms.size());
 
Index: src/Parser/MpqcParser.hpp
===================================================================
--- src/Parser/MpqcParser.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Parser/MpqcParser.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,5 @@
 #include "FormatParser.hpp"
 
-#include <iostream>
+#include <iosfwd>
 
 /**
